(*1*)let addn m n = m + n
(*2*)
(*3*)let add_one m = addn 1
(*4*)
(*5*)let add_two m = addn 2
(*6*)
(*7*)let rec f m = 
(*8*)  if m=0 
(*9*)  then [] 
(*10*)  else (addn m)::(f (m-1))
(*11*)
(*12*)let rec map f lst =
(*13*)  match lst with
(*14*)    []     -> []
(*15*)  | hd::tl -> (f hd)::(map f tl)
(*16*)
(*17*)(* just a function pointer *)
(*18*)let incr lst = map (fun x -> x+1) lst
(*19*)let incr = map (fun x -> x+1)
(*20*)(* a closure *)
(*21*)let mul i lst = map (fun x -> x*i) lst
(*22*)let mul i = map (fun x -> x*i)
(*23*)
(*24*)let rec fold_left f acc lst =
(*25*)  match lst with
(*26*)    []     -> acc
(*27*)  | hd::tl -> fold_left f (f acc hd) tl
(*28*)
(*29*)(* just function pointers *)
(*30*)let f1 = fold_left (fun x y -> x+y) 0
(*31*)let f2 = fold_left (fun x y -> x && y>0) true
(*32*)(* a closure *)
(*33*)let f1 lst lo hi = 
(*34*) fold_left 
(*35*) (fun x y -> if y>lo && y<hi then x+1 else x)
(*36*) 0
(*37*) lst
(*38*)
(*39*)let f1 g h = (fun x -> g (h x))
(*40*)
(*41*)type 'a option = None | Some of 'a (*predefined*)
(*42*)
(*43*)let f2 g h x = 
(*44*)  match g x with
(*45*)    None   -> h x
(*46*)  | Some y -> y
(*47*)
(*48*)(* do not need a datatype if you compile with -rectypes *)
(*49*)type set = { add : int -> set; member : int -> bool }
(*50*)
(*51*)let empty_set = 
(*52*)  let exists lst j = (*could use fold_left!*)
(*53*)     let rec iter rest =
(*54*)        match rest with 
(*55*)          [] -> false 
(*56*)        | hd::tl -> j=hd || iter tl in
(*57*)     iter lst in
(*58*)  let rec make_set lst = 
(*59*)     { add    = (fun i -> make_set(i::lst));
(*60*)       member = exists lst } in
(*61*)  make_set []
